Object.defineProperty(exports, "__esModule", { value: true });
exports.getLayout = exports.setFocusable = exports.handleClearFocus = exports.createRippleDrawable = exports.getAttrColor = exports.createStateListAnimator = exports.getFocusedColorStateList = exports.getEnabledColorStateList = exports.getRippleColorStateList = exports.stateSets = exports.state = exports.isPostMarshmallow = exports.isPostLollipopMR1 = exports.isPostLollipop = void 0;
var application = require("@nativescript/core/application");
var color_1 = require("@nativescript/core/color");
var utils_1 = require("@nativescript/core/utils/utils");
var isPostLollipopVar = undefined;
function isPostLollipop() {
    if (isPostLollipopVar === undefined) {
        isPostLollipopVar = android.os.Build.VERSION.SDK_INT >= 21;
    }
    return isPostLollipopVar;
}
exports.isPostLollipop = isPostLollipop;
var isPostLollipopMR1Var = undefined;
function isPostLollipopMR1() {
    if (isPostLollipopMR1Var === undefined) {
        isPostLollipopMR1Var = android.os.Build.VERSION.SDK_INT >= 22;
    }
    return isPostLollipopMR1Var;
}
exports.isPostLollipopMR1 = isPostLollipopMR1;
var isPostMarshmallowVar = undefined;
function isPostMarshmallow() {
    if (isPostMarshmallowVar === undefined) {
        isPostMarshmallowVar = android.os.Build.VERSION.SDK_INT >= 23;
    }
    return isPostMarshmallowVar;
}
exports.isPostMarshmallow = isPostMarshmallow;
exports.state = {
    get selected() {
        return 16842913;
    },
    get hovered() {
        return 16843623;
    },
    get focused() {
        return 16842908;
    },
    get enabled() {
        return 16842910;
    },
    get pressed() {
        return 16842919;
    },
    get window_focused() {
        return 16842909;
    },
    get checked() {
        return 16842912;
    }
};
function createNativeArray() {
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
    }
    var result = Array.create('int', args.length);
    args.forEach(function (a, i) { return (result[i] = a); });
    return result;
}
exports.stateSets = {
    get PRESSED_STATE_SET() {
        if (!this._PRESSED_STATE_SET) {
            this._PRESSED_STATE_SET = createNativeArray(exports.state.pressed);
        }
        return this._PRESSED_STATE_SET;
    },
    get HOVERED_FOCUSED_STATE_SET() {
        if (!this._HOVERED_FOCUSED_STATE_SET) {
            this._HOVERED_FOCUSED_STATE_SET = createNativeArray(exports.state.hovered, exports.state.focused);
        }
        return this._PRESSED_STATE_SET;
    },
    get FOCUSED_STATE_SET() {
        if (!this._FOCUSED_STATE_SET) {
            this._FOCUSED_STATE_SET = createNativeArray(exports.state.focused);
        }
        return this._FOCUSED_STATE_SET;
    },
    get HOVERED_STATE_SET() {
        if (!this._HOVERED_STATE_SET) {
            this._HOVERED_STATE_SET = createNativeArray(exports.state.hovered);
        }
        return this._HOVERED_STATE_SET;
    },
    get SELECTED_PRESSED_STATE_SET() {
        if (!this._SELECTED_PRESSED_STATE_SET) {
            this._SELECTED_PRESSED_STATE_SET = createNativeArray(exports.state.enabled, exports.state.pressed);
        }
        return this._SELECTED_PRESSED_STATE_SET;
    },
    get SELECTED_HOVERED_FOCUSED_STATE_SET() {
        if (!this._SELECTED_HOVERED_FOCUSED_STATE_SET) {
            this._SELECTED_HOVERED_FOCUSED_STATE_SET = createNativeArray(exports.state.selected, exports.state.hovered, exports.state.focused);
        }
        return this._SELECTED_HOVERED_FOCUSED_STATE_SET;
    },
    get SELECTED_FOCUSED_STATE_SET() {
        if (!this._SELECTED_FOCUSED_STATE_SET) {
            this._SELECTED_FOCUSED_STATE_SET = createNativeArray(exports.state.selected, exports.state.focused);
        }
        return this._SELECTED_FOCUSED_STATE_SET;
    },
    get SELECTED_HOVERED_STATE_SET() {
        if (!this._SELECTED_HOVERED_STATE_SET) {
            this._SELECTED_HOVERED_STATE_SET = createNativeArray(exports.state.selected, exports.state.hovered);
        }
        return this._SELECTED_HOVERED_STATE_SET;
    },
    get SELECTED_STATE_SET() {
        if (!this._SELECTED_STATE_SET) {
            this._SELECTED_STATE_SET = createNativeArray(exports.state.selected);
        }
        return this._SELECTED_STATE_SET;
    },
    get BACKGROUND_DEFAULT_STATE_1() {
        if (!this._BACKGROUND_DEFAULT_STATE_1) {
            this._BACKGROUND_DEFAULT_STATE_1 = createNativeArray(exports.state.window_focused, exports.state.enabled);
        }
        return this._BACKGROUND_DEFAULT_STATE_1;
    },
    get BACKGROUND_DEFAULT_STATE_2() {
        if (!this._BACKGROUND_DEFAULT_STATE_1_SET) {
            this._BACKGROUND_DEFAULT_STATE_1_SET = createNativeArray(exports.state.enabled);
        }
        return this._BACKGROUND_DEFAULT_STATE_1_SET;
    },
    get BACKGROUND_SELECTED_STATE() {
        if (!this._BACKGROUND_SELECTED_STATE) {
            this._BACKGROUND_SELECTED_STATE = createNativeArray(exports.state.window_focused, exports.state.enabled, exports.state.pressed);
        }
        return this._BACKGROUND_SELECTED_STATE;
    },
    get BACKGROUND_CHECKED_STATE() {
        if (!this._BACKGROUND_CHECKED_STATE) {
            this._BACKGROUND_CHECKED_STATE = createNativeArray(exports.state.window_focused, exports.state.enabled, exports.state.checked);
        }
        return this._BACKGROUND_CHECKED_STATE;
    },
    get BACKGROUND_FOCUSED_STATE() {
        if (!this._BACKGROUND_FOCUSED_STATE) {
            this._BACKGROUND_FOCUSED_STATE = createNativeArray(exports.state.focused, exports.state.window_focused, exports.state.enabled);
        }
        return this._BACKGROUND_FOCUSED_STATE;
    },
    get BACKGROUND_DISABLED_STATE() {
        if (!this._BACKGROUND_DISABLED_STATE) {
            this._BACKGROUND_DISABLED_STATE = createNativeArray(-exports.state.enabled);
        }
        return this._BACKGROUND_DISABLED_STATE;
    }
};
function getRippleColorStateList(color) {
    var states = Array.create('[I', 2);
    states[0] = exports.stateSets.SELECTED_PRESSED_STATE_SET;
    states[1] = Array.create('int', 0);
    var colors = Array.create('int', 2);
    colors[0] = color;
    colors[1] = 0;
    return new android.content.res.ColorStateList(states, colors);
}
exports.getRippleColorStateList = getRippleColorStateList;
function getEnabledColorStateList(color, variant) {
    var states = Array.create('[I', 2);
    states[0] = Array.create('int', 1);
    states[0][0] = -exports.state.enabled;
    states[1] = android.util.StateSet.NOTHING;
    var colors = Array.create('int', 2);
    colors[0] = variant === 'text' || variant === 'outline' ? 0 : new color_1.Color(30, 0, 0, 0).android;
    colors[1] = color;
    return new android.content.res.ColorStateList(states, colors);
}
exports.getEnabledColorStateList = getEnabledColorStateList;
function getFocusedColorStateList(color, variant) {
    var states = Array.create('[I', 3);
    states[0] = Array.create('int', 1);
    states[0][0] = exports.state.pressed;
    states[1] = Array.create('int', 2);
    states[1][0] = exports.state.enabled;
    states[1][1] = exports.state.focused;
    states[2] = android.util.StateSet.NOTHING;
    var colors = Array.create('int', 4);
    colors[0] = color;
    colors[1] = color;
    colors[2] = color;
    colors[2] = new color_1.Color(255, 160, 160, 160).android;
    return new android.content.res.ColorStateList(states, colors);
}
exports.getFocusedColorStateList = getFocusedColorStateList;
var shortAnimTime = 17694720;
var statePressed = 16842919;
var stateEnabled = 16842910;
function createStateListAnimator(view, nativeView) {
    var ObjectAnimator = android.animation.ObjectAnimator;
    var AnimatorSet = android.animation.AnimatorSet;
    var duration = nativeView
        .getContext()
        .getResources()
        .getInteger(shortAnimTime) / 2;
    var elevation = view['elevation'];
    if (typeof elevation === 'undefined' || elevation === null) {
        elevation = view.getDefaultElevation();
    }
    elevation = utils_1.layout.toDevicePixels(elevation);
    var pressedZ = view['dynamicElevationOffset'];
    if (typeof pressedZ === 'undefined' || pressedZ === null) {
        pressedZ = view.getDefaultDynamicElevationOffset();
    }
    pressedZ = utils_1.layout.toDevicePixels(pressedZ);
    var pressedSet = new AnimatorSet();
    pressedSet.playTogether(java.util.Arrays.asList([ObjectAnimator.ofFloat(nativeView, 'translationZ', [pressedZ]).setDuration(duration), ObjectAnimator.ofFloat(nativeView, 'elevation', [elevation]).setDuration(0)]));
    var notPressedSet = new AnimatorSet();
    notPressedSet.playTogether(java.util.Arrays.asList([ObjectAnimator.ofFloat(nativeView, 'translationZ', [0]).setDuration(duration), ObjectAnimator.ofFloat(nativeView, 'elevation', [elevation]).setDuration(0)]));
    var defaultSet = new AnimatorSet();
    defaultSet.playTogether(java.util.Arrays.asList([ObjectAnimator.ofFloat(nativeView, 'translationZ', [0]).setDuration(0), ObjectAnimator.ofFloat(nativeView, 'elevation', [0]).setDuration(0)]));
    var stateListAnimator = new android.animation.StateListAnimator();
    stateListAnimator.addState([statePressed, stateEnabled], pressedSet);
    stateListAnimator.addState([stateEnabled], notPressedSet);
    stateListAnimator.addState([], defaultSet);
    nativeView.setStateListAnimator(stateListAnimator);
}
exports.createStateListAnimator = createStateListAnimator;
function getAttrColor(context, name) {
    var ta = context.obtainStyledAttributes([utils_1.ad.resources.getId(':attr/' + name)]);
    var color = ta.getColor(0, 0);
    ta.recycle();
    return color;
}
exports.getAttrColor = getAttrColor;
function createForegroundShape(radius) {
    var radii = Array.create('float', 8);
    java.util.Arrays.fill(radii, radius);
    var shape = new android.graphics.drawable.shapes.RoundRectShape(radii, null, null);
    var shapeDrawable = new android.graphics.drawable.ShapeDrawable(shape);
    return shapeDrawable;
}
function createRippleDrawable(view, rippleColor, radius) {
    if (radius === void 0) { radius = 0; }
    var rippleShape = createForegroundShape(radius);
    var rippleDrawable;
    if (isPostLollipopMR1()) {
        rippleDrawable = new android.graphics.drawable.RippleDrawable(android.content.res.ColorStateList.valueOf(rippleColor), null, rippleShape);
    }
    else {
        rippleDrawable = new android.graphics.drawable.StateListDrawable();
        rippleShape.getPaint().setColor(rippleColor);
        rippleDrawable.addState([exports.state.pressed], rippleShape);
    }
    rippleDrawable.rippleShape = rippleShape;
    return rippleDrawable;
}
exports.createRippleDrawable = createRippleDrawable;
function handleClearFocus(view) {
    var root = view.getRootView();
    var oldValue = true;
    var oldDesc = android.view.ViewGroup.FOCUS_BEFORE_DESCENDANTS;
    if (root != null) {
        if (root instanceof android.view.ViewGroup) {
            oldDesc = root.getDescendantFocusability();
            root.setDescendantFocusability(android.view.ViewGroup.FOCUS_BLOCK_DESCENDANTS);
        }
        oldValue = root.isFocusable();
        setFocusable(root, false);
    }
    view.clearFocus();
    if (root != null) {
        setFocusable(root, oldValue);
        if (root instanceof android.view.ViewGroup) {
            root.setDescendantFocusability(oldDesc);
        }
    }
}
exports.handleClearFocus = handleClearFocus;
function setFocusable(view, focusable) {
    view.setFocusable(focusable);
    view.setFocusableInTouchMode(focusable);
}
exports.setFocusable = setFocusable;
function getLayout(id) {
    if (!id) {
        return 0;
    }
    var context = application.android.context;
    return context.getResources().getIdentifier(id, 'layout', context.getPackageName());
}
exports.getLayout = getLayout;
//# sourceMappingURL=utils.js.map