Object.defineProperty(exports, "__esModule", { value: true });
exports.installMixins = exports.overrideViewBase = exports.getRippleColor = exports.install = exports.themer = exports.Themer = exports.applyMixins = void 0;
var utils_1 = require("./android/utils");
var application = require("@nativescript/core/application");
var color_1 = require("@nativescript/core/color");
var button_1 = require("@nativescript/core/ui/button");
var view_1 = require("@nativescript/core/ui/core/view");
var style_properties_1 = require("@nativescript/core/ui/styling/style-properties");
var core_common_1 = require("./core.common");
Object.defineProperty(exports, "applyMixins", { enumerable: true, get: function () { return core_common_1.applyMixins; } });
var cssproperties_1 = require("./cssproperties");
var Themer = (function () {
    function Themer() {
    }
    Themer.prototype.getOrcreateAppColorScheme = function () {
    };
    Themer.prototype.getAppColorScheme = function () {
    };
    Themer.prototype.setPrimaryColor = function (value) {
        this.primaryColor = value;
    };
    Themer.prototype.getPrimaryColor = function () {
        if (!this.primaryColor) {
            this.primaryColor = new color_1.Color(utils_1.getAttrColor(application.android.startActivity, 'colorPrimary'));
        }
        return this.primaryColor;
    };
    Themer.prototype.setAccentColor = function (value) {
        if (!this.accentColor) {
            this.accentColor = new color_1.Color(utils_1.getAttrColor(application.android.startActivity, 'colorAccent'));
        }
        this.accentColor = value;
    };
    Themer.prototype.getAccentColor = function () {
        return this.accentColor;
    };
    Themer.prototype.setSurfaceColor = function (value) {
        this.surfaceColor = value;
    };
    Themer.prototype.getSurfaceColor = function () {
        return this.surfaceColor;
    };
    Themer.prototype.setOnSurfaceColor = function (value) {
        this.onSurfaceColor = value;
    };
    Themer.prototype.getOnSurfaceColor = function () {
        return this.onSurfaceColor;
    };
    Themer.prototype.setPrimaryColorVariant = function (value) {
        this.primaryColorVariant = value;
    };
    Themer.prototype.getPrimaryColorVariant = function () {
        if (!this.primaryColorVariant) {
            this.primaryColorVariant = new color_1.Color(utils_1.getAttrColor(application.android.context, 'colorSecondary'));
        }
        return this.primaryColorVariant;
    };
    Themer.prototype.setSecondaryColor = function (value) {
        this.secondaryColor = value;
    };
    Themer.prototype.getSecondaryColor = function () {
        return this.secondaryColor;
    };
    return Themer;
}());
exports.Themer = Themer;
exports.themer = new Themer();
function install() {
}
exports.install = install;
function getRippleColor(color) {
    if (color) {
        var temp = typeof color === 'string' ? new color_1.Color(color) : color;
        return new color_1.Color(temp.a !== 255 ? temp.a : 61.5, temp.r, temp.g, temp.b).android;
    }
    return null;
}
exports.getRippleColor = getRippleColor;
var ViewWithElevationAndRipple = (function (_super) {
    __extends(ViewWithElevationAndRipple, _super);
    function ViewWithElevationAndRipple() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.elevation = 0;
        _this.dynamicElevationOffset = 0;
        return _this;
    }
    ViewWithElevationAndRipple.prototype.getRippleColor = function () {
        return getRippleColor(this.style['rippleColor'] ? this.style['rippleColor'] : new color_1.Color(utils_1.getAttrColor(this._context, 'colorControlHighlight')));
    };
    ViewWithElevationAndRipple.prototype.getCornerRadius = function () {
        return getRippleColor(this.style['rippleColor'] ? this.style['rippleColor'] : new color_1.Color(utils_1.getAttrColor(this._context, 'colorControlHighlight')));
    };
    ViewWithElevationAndRipple.prototype.setRippleDrawable = function (view, radius) {
        if (radius === void 0) { radius = 0; }
        if (!this.rippleDrawable) {
            this.rippleDrawable = utils_1.createRippleDrawable(view, this.getRippleColor(), radius);
            if (utils_1.isPostMarshmallow()) {
                view.setForeground(this.rippleDrawable);
            }
        }
    };
    ViewWithElevationAndRipple.prototype[cssproperties_1.rippleColorProperty.setNative] = function (color) {
        var rippleColor = getRippleColor(color);
        if (this instanceof button_1.Button) {
            var foreground = this.nativeViewProtected.getForeground();
            if (foreground instanceof android.graphics.drawable.RippleDrawable) {
                foreground.setColor(android.content.res.ColorStateList.valueOf(rippleColor));
                return;
            }
            var background = this.nativeViewProtected.getBackground();
            if (background instanceof android.graphics.drawable.RippleDrawable) {
                background.setColor(android.content.res.ColorStateList.valueOf(rippleColor));
                return;
            }
        }
        this.nativeViewProtected.setClickable(this.isUserInteractionEnabled);
        this.setRippleDrawable(this.nativeViewProtected, style_properties_1.Length.toDevicePixels(this.style.borderTopLeftRadius));
        if (utils_1.isPostLollipopMR1()) {
            this.rippleDrawable.setColor(android.content.res.ColorStateList.valueOf(rippleColor));
        }
        else {
            this.rippleDrawable.rippleShape.getPaint().setColor(rippleColor);
        }
    };
    ViewWithElevationAndRipple.prototype[view_1.backgroundInternalProperty.setNative] = function (value) {
        if (this.nativeViewProtected) {
            if (value instanceof android.graphics.drawable.Drawable) {
            }
            else {
                if (this.rippleDrawable || (value.color && this instanceof button_1.Button && this.rippleColor)) {
                    this.rippleDrawable = null;
                    this.setRippleDrawable(this.nativeViewProtected, value.borderTopLeftRadius);
                }
            }
        }
    };
    ViewWithElevationAndRipple.prototype.getDefaultElevation = function () {
        var result = this instanceof button_1.Button ? 2 : 0;
        return result;
    };
    ViewWithElevationAndRipple.prototype.getDefaultDynamicElevationOffset = function () {
        var result = this instanceof button_1.Button ? 6 : 0;
        return result;
    };
    ViewWithElevationAndRipple.prototype[cssproperties_1.elevationProperty.setNative] = function (value) {
        if (utils_1.isPostLollipop()) {
            utils_1.createStateListAnimator(this, this.nativeViewProtected);
        }
        else {
            var newValue = style_properties_1.Length.toDevicePixels(typeof value === 'string' ? style_properties_1.Length.parse(value) : value, 0);
            this.nativeViewProtected.setElevation(newValue);
        }
    };
    ViewWithElevationAndRipple.prototype[cssproperties_1.dynamicElevationOffsetProperty.setNative] = function (value) {
        this.nativeViewProtected.setClickable(this.isUserInteractionEnabled);
        if (utils_1.isPostLollipop()) {
            utils_1.createStateListAnimator(this, this.nativeViewProtected);
        }
        else {
            var newValue = style_properties_1.Length.toDevicePixels(typeof value === 'string' ? style_properties_1.Length.parse(value) : value, 0);
            this.nativeViewProtected.setTranslationZ(newValue);
        }
    };
    ViewWithElevationAndRipple.prototype[style_properties_1.androidElevationProperty.setNative] = function (value) {
    };
    ViewWithElevationAndRipple.prototype[style_properties_1.androidDynamicElevationOffsetProperty.setNative] = function (value) {
    };
    __decorate([
        cssproperties_1.cssProperty,
        __metadata("design:type", Number)
    ], ViewWithElevationAndRipple.prototype, "elevation", void 0);
    __decorate([
        cssproperties_1.cssProperty,
        __metadata("design:type", Number)
    ], ViewWithElevationAndRipple.prototype, "dynamicElevationOffset", void 0);
    __decorate([
        cssproperties_1.cssProperty,
        __metadata("design:type", color_1.Color)
    ], ViewWithElevationAndRipple.prototype, "rippleColor", void 0);
    return ViewWithElevationAndRipple;
}(view_1.View));
var mixinInstalled = false;
function overrideViewBase() {
    var NSView = require('@nativescript/core/ui/core/view').View;
    core_common_1.applyMixins(NSView, [ViewWithElevationAndRipple]);
}
exports.overrideViewBase = overrideViewBase;
function installMixins() {
    if (!mixinInstalled) {
        mixinInstalled = true;
        overrideViewBase();
    }
}
exports.installMixins = installMixins;
//# sourceMappingURL=core.android.js.map