Object.defineProperty(exports, "__esModule", { value: true });
exports.applyMixins = void 0;
function applyMixins(derivedCtor, baseCtors, options) {
    var omits = options && options.omit ? options.omit : [];
    baseCtors.forEach(function (baseCtor) {
        Object.getOwnPropertyNames(baseCtor.prototype).forEach(function (name) {
            if (omits.indexOf(name) !== -1) {
                return;
            }
            var descriptor = Object.getOwnPropertyDescriptor(baseCtor.prototype, name);
            if (name === 'constructor')
                return;
            if (descriptor && (!descriptor.writable || !descriptor.configurable || descriptor.get || descriptor.set)) {
                Object.defineProperty(derivedCtor.prototype, name, descriptor);
            }
            else {
                var oldImpl_1 = derivedCtor.prototype[name];
                if (!oldImpl_1) {
                    derivedCtor.prototype[name] = baseCtor.prototype[name];
                }
                else {
                    derivedCtor.prototype[name] = function () {
                        var args = [];
                        for (var _i = 0; _i < arguments.length; _i++) {
                            args[_i] = arguments[_i];
                        }
                        if (options) {
                            if (!!options.override) {
                                return baseCtor.prototype[name].apply(this, args);
                            }
                            else if (!!options.after) {
                                oldImpl_1.apply(this, args);
                                return baseCtor.prototype[name].apply(this, args);
                            }
                            else {
                                baseCtor.prototype[name].apply(this, args);
                                return oldImpl_1.apply(this, args);
                            }
                        }
                        else {
                            baseCtor.prototype[name].apply(this, args);
                            return oldImpl_1.apply(this, args);
                        }
                    };
                }
            }
        });
        Object.getOwnPropertySymbols(baseCtor.prototype).forEach(function (symbol) {
            if (omits.indexOf(symbol) !== -1) {
                return;
            }
            var oldImpl = derivedCtor.prototype[symbol];
            if (!oldImpl) {
                derivedCtor.prototype[symbol] = baseCtor.prototype[symbol];
            }
            else {
                derivedCtor.prototype[symbol] = function () {
                    var args = [];
                    for (var _i = 0; _i < arguments.length; _i++) {
                        args[_i] = arguments[_i];
                    }
                    if (options) {
                        if (!!options.override) {
                            return baseCtor.prototype[symbol].apply(this, args);
                        }
                        else if (!!options.after) {
                            oldImpl.apply(this, args);
                            return baseCtor.prototype[symbol].apply(this, args);
                        }
                        else {
                            baseCtor.prototype[symbol].apply(this, args);
                            return oldImpl.apply(this, args);
                        }
                    }
                    else {
                        baseCtor.prototype[symbol].apply(this, args);
                        return oldImpl.apply(this, args);
                    }
                };
            }
        });
    });
}
exports.applyMixins = applyMixins;
//# sourceMappingURL=core.common.js.map