import { Color } from '@nativescript/core';
import { TypographyOptions } from './core';
import { applyMixins } from './core.common';
export { applyMixins };
export declare class Themer {
    appColorScheme: MDCSemanticColorScheme;
    appTypoScheme: MDCTypographyScheme;
    primaryColor: string | Color;
    secondaryColor: string | Color;
    accentColor: string | Color;
    primaryColorVariant: string | Color;
    surfaceColor: string | Color;
    onSurfaceColor: string | Color;
    constructor();
    getOrcreateAppColorScheme(): MDCSemanticColorScheme;
    getAppColorScheme(): MDCSemanticColorScheme;
    setPrimaryColor(value: string | Color): void;
    getPrimaryColor(): string | Color;
    setSecondaryColor(value: string | Color): void;
    getSecondaryColor(): string | Color;
    setAccentColor(value: string | Color): void;
    getAccentColor(): string | Color;
    setSurfaceColor(value: string | Color): void;
    getSurfaceColor(): string | Color;
    setOnSurfaceColor(value: string | Color): void;
    getOnSurfaceColor(): string | Color;
    setPrimaryColorVariant(value: string | Color): void;
    getPrimaryColorVariant(): string | Color;
    getOrcreateAppTypographyScheme(): MDCTypographyScheme;
    getAppTypographyScheme(): MDCTypographyScheme;
    setButtonTypography(args: TypographyOptions): void;
}
export declare const themer: Themer;
export declare function install(): void;
export declare function getRippleColor(color: string | Color): UIColor;
export declare function overrideViewBase(): void;
export declare function installMixins(): void;
