Object.defineProperty(exports, "__esModule", { value: true });
exports.installMixins = exports.overrideViewBase = exports.getRippleColor = exports.install = exports.themer = exports.Themer = exports.applyMixins = void 0;
var core_1 = require("@nativescript/core");
var gestures_1 = require("@nativescript/core/ui/gestures");
var page_1 = require("@nativescript/core/ui/page");
var control_state_change_1 = require("@nativescript/core/ui/core/control-state-change");
var core_common_1 = require("./core.common");
Object.defineProperty(exports, "applyMixins", { enumerable: true, get: function () { return core_common_1.applyMixins; } });
var cssproperties_1 = require("./cssproperties");
var Themer = (function () {
    function Themer() {
        this.appColorScheme = MDCSemanticColorScheme.new();
        this.appColorScheme.primaryColorVariant = this.appColorScheme.primaryColor.colorWithAlphaComponent(0.24);
    }
    Themer.prototype.getOrcreateAppColorScheme = function () {
        if (!this.appColorScheme) {
            this.appColorScheme = MDCSemanticColorScheme.new();
        }
        return this.appColorScheme;
    };
    Themer.prototype.getAppColorScheme = function () {
        return this.appColorScheme;
    };
    Themer.prototype.setPrimaryColor = function (value) {
        this.primaryColor = value;
        var colorTheme = this.getOrcreateAppColorScheme();
        var color = value instanceof core_1.Color ? value : new core_1.Color(value);
        colorTheme.primaryColor = color.ios;
        colorTheme.primaryColorVariant = new core_1.Color(61.2, color.r, color.g, color.b).ios;
    };
    Themer.prototype.getPrimaryColor = function () {
        return this.primaryColor;
    };
    Themer.prototype.setSecondaryColor = function (value) {
        this.secondaryColor = value;
        var colorTheme = this.getOrcreateAppColorScheme();
        var color = value instanceof core_1.Color ? value : new core_1.Color(value);
        colorTheme.secondaryColor = color.ios;
    };
    Themer.prototype.getSecondaryColor = function () {
        return this.secondaryColor;
    };
    Themer.prototype.setAccentColor = function (value) {
        this.accentColor = value;
    };
    Themer.prototype.getAccentColor = function () {
        return this.accentColor;
    };
    Themer.prototype.setSurfaceColor = function (value) {
        this.surfaceColor = value;
        var colorTheme = this.getOrcreateAppColorScheme();
        var color = value instanceof core_1.Color ? value : new core_1.Color(value);
        colorTheme.surfaceColor = color.ios;
        colorTheme.onSurfaceColor = color.ios;
    };
    Themer.prototype.getSurfaceColor = function () {
        return this.surfaceColor;
    };
    Themer.prototype.setOnSurfaceColor = function (value) {
        this.onSurfaceColor = value;
        var colorTheme = this.getOrcreateAppColorScheme();
        var color = value instanceof core_1.Color ? value : new core_1.Color(value);
        colorTheme.onSurfaceColor = color.ios;
    };
    Themer.prototype.getOnSurfaceColor = function () {
        return this.onSurfaceColor;
    };
    Themer.prototype.setPrimaryColorVariant = function (value) {
        this.primaryColorVariant = value;
        var color = value instanceof core_1.Color ? value : new core_1.Color(value);
        this.getOrcreateAppColorScheme().primaryColorVariant = color.ios;
    };
    Themer.prototype.getPrimaryColorVariant = function () {
        return this.primaryColorVariant;
    };
    Themer.prototype.getOrcreateAppTypographyScheme = function () {
        if (!this.appTypoScheme) {
            this.appTypoScheme = MDCTypographyScheme.new();
        }
        return this.appTypoScheme;
    };
    Themer.prototype.getAppTypographyScheme = function () {
        return this.appTypoScheme;
    };
    Themer.prototype.setButtonTypography = function (args) {
    };
    return Themer;
}());
exports.Themer = Themer;
exports.themer = new Themer();
function install() {
}
exports.install = install;
function getRippleColor(color) {
    if (color) {
        var temp = typeof color === 'string' ? new core_1.Color(color) : color;
        return new core_1.Color(temp.a !== 255 ? temp.a : 61.5, temp.r, temp.g, temp.b).ios;
    }
    return null;
}
exports.getRippleColor = getRippleColor;
var ViewWithElevationAndRipple = (function (_super) {
    __extends(ViewWithElevationAndRipple, _super);
    function ViewWithElevationAndRipple() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._shadowElevations = {};
        return _this;
    }
    ViewWithElevationAndRipple.prototype.getOrCreateRippleController = function () {
        if (!this.inkTouchController) {
            this.inkTouchController = MDCInkTouchController.alloc().initWithView(this.nativeViewProtected);
            this.inkTouchController.addInkView();
            var colorScheme = exports.themer.getAppColorScheme();
            MDCInkColorThemer.applyColorSchemeToInkView(colorScheme, this.inkTouchController.defaultInkView);
            if (this.style.backgroundInternal) {
                this.inkTouchController.defaultInkView.layer.cornerRadius = core_1.Utils.layout.toDeviceIndependentPixels(this.style.backgroundInternal.borderTopLeftRadius);
            }
        }
        return this.inkTouchController;
    };
    ViewWithElevationAndRipple.prototype.getOrCreateShadowLayer = function () {
        if (!this.shadowLayer) {
            this._shadowElevations = this._shadowElevations || {};
            var layer = (this.shadowLayer = MDCShadowLayer.alloc().init());
            layer.shouldRasterize = true;
            layer.rasterizationScale = UIScreen.mainScreen.scale;
            layer.frame = this.nativeViewProtected.layer.bounds;
            this.nativeViewProtected.layer.addSublayer(this.shadowLayer);
            this['clipToBounds'] = false;
            this.nativeViewProtected.clipsToBounds = false;
            if (this.style.backgroundInternal) {
                layer.cornerRadius = core_1.Utils.layout.toDeviceIndependentPixels(this.style.backgroundInternal.borderTopLeftRadius);
            }
            if (this.nativeViewProtected instanceof UIControl) {
                this.startElevationStateChangeHandler();
            }
        }
        return this.shadowLayer;
    };
    ViewWithElevationAndRipple.prototype._onSizeChanged = function () {
        if (this.nativeViewProtected && this.shadowLayer) {
            this.shadowLayer.frame = this.nativeViewProtected.layer.bounds;
        }
    };
    ViewWithElevationAndRipple.prototype._setNativeClipToBounds = function () {
        if (this.shadowLayer) {
            this.nativeViewProtected.clipsToBounds = false;
        }
    };
    ViewWithElevationAndRipple.prototype.onUnloaded = function () {
        if (this._elevationStateChangedHandler) {
            if (this._elevationStateChangedHandler.stop) {
                this._elevationStateChangedHandler.stop();
            }
            else {
                this.off(core_1.GestureTypes.touch, this._elevationStateChangedHandler);
            }
        }
    };
    ViewWithElevationAndRipple.prototype.updateShadowElevation = function (state) {
        if (this.shadowLayer) {
            var elevation = this._shadowElevations[state];
            this.shadowLayer.elevation = elevation;
        }
    };
    ViewWithElevationAndRipple.prototype[cssproperties_1.rippleColorProperty.setNative] = function (color) {
        this.getOrCreateRippleController();
        this.inkTouchController.defaultInkView.inkColor = getRippleColor(color);
    };
    ViewWithElevationAndRipple.prototype.startElevationStateChangeHandler = function () {
        var _this = this;
        if (!this._elevationStateChangedHandler) {
            if (this.nativeViewProtected instanceof UIControl) {
                this._elevationStateChangedHandler =
                    this._elevationStateChangedHandler ||
                        new control_state_change_1.ControlStateChangeListener(this.nativeViewProtected, function (s) {
                            _this.updateShadowElevation(s);
                        });
                this._elevationStateChangedHandler.start();
            }
            else {
                this._elevationStateChangedHandler =
                    this._elevationStateChangedHandler ||
                        (function (args) {
                            switch (args.action) {
                                case gestures_1.TouchAction.up:
                                    _this.updateShadowElevation('normal');
                                    break;
                                case gestures_1.TouchAction.down:
                                    _this.updateShadowElevation('highlighted');
                                    break;
                            }
                        });
                this.on(core_1.GestureTypes.touch, this._elevationStateChangedHandler);
            }
        }
    };
    ViewWithElevationAndRipple.prototype.getDefaultElevation = function () {
        return this instanceof core_1.Button ? 2 : 0;
    };
    ViewWithElevationAndRipple.prototype.getDefaultDynamicElevationOffset = function () {
        return this instanceof core_1.Button ? 6 : 0;
    };
    ViewWithElevationAndRipple.prototype[cssproperties_1.elevationProperty.getDefault] = function () {
        return this.getDefaultElevation();
    };
    ViewWithElevationAndRipple.prototype[cssproperties_1.elevationProperty.setNative] = function (value) {
        this.getOrCreateShadowLayer();
        var dynamicElevationOffset = this.dynamicElevationOffset;
        if (typeof dynamicElevationOffset === 'undefined' || dynamicElevationOffset === null) {
            dynamicElevationOffset = this.getDefaultDynamicElevationOffset();
        }
        if (dynamicElevationOffset !== 0) {
            this.startElevationStateChangeHandler();
        }
        this._shadowElevations['normal'] = value;
        this._shadowElevations['highlighted'] = value + dynamicElevationOffset;
        this.shadowLayer.elevation = value;
    };
    ViewWithElevationAndRipple.prototype[cssproperties_1.dynamicElevationOffsetProperty.getDefault] = function () {
        return this.getDefaultDynamicElevationOffset();
    };
    ViewWithElevationAndRipple.prototype[cssproperties_1.dynamicElevationOffsetProperty.setNative] = function (value) {
        this.getOrCreateShadowLayer();
        this.startElevationStateChangeHandler();
        var elevation = this.elevation;
        if (typeof elevation === 'undefined' || elevation === null) {
            elevation = this.getDefaultElevation();
        }
        this._shadowElevations['normal'] = elevation;
        this._shadowElevations['highlighted'] = value + elevation;
    };
    ViewWithElevationAndRipple.prototype[page_1.backgroundInternalProperty.setNative] = function (value) {
        if (this.inkTouchController) {
            this.inkTouchController.defaultInkView.layer.cornerRadius = core_1.Utils.layout.toDeviceIndependentPixels(value.borderTopLeftRadius);
        }
    };
    __decorate([
        cssproperties_1.cssProperty,
        __metadata("design:type", Number)
    ], ViewWithElevationAndRipple.prototype, "elevation", void 0);
    __decorate([
        cssproperties_1.cssProperty,
        __metadata("design:type", Number)
    ], ViewWithElevationAndRipple.prototype, "dynamicElevationOffset", void 0);
    __decorate([
        cssproperties_1.cssProperty,
        __metadata("design:type", core_1.Color)
    ], ViewWithElevationAndRipple.prototype, "rippleColor", void 0);
    return ViewWithElevationAndRipple;
}(core_1.View));
function overrideViewBase() {
    var NSView = require('@nativescript/core').View;
    core_common_1.applyMixins(NSView, [ViewWithElevationAndRipple], {
        after: true,
    });
}
exports.overrideViewBase = overrideViewBase;
var mixinInstalled = false;
function installMixins() {
    if (!mixinInstalled) {
        mixinInstalled = true;
        overrideViewBase();
    }
}
exports.installMixins = installMixins;
//# sourceMappingURL=core.ios.js.map