Object.defineProperty(exports, "__esModule", { value: true });
exports.verticalTextAlignmentProperty = exports.variantProperty = exports.dynamicElevationOffsetProperty = exports.elevationProperty = exports.rippleColorProperty = exports.cssProperty = void 0;
var core_1 = require("@nativescript/core");
var properties_1 = require("@nativescript/core/ui/core/properties/properties");
function createGetter(key) {
    return function () {
        return this.style[key];
    };
}
function createSetter(key) {
    return function (newVal) {
        this.style[key] = newVal;
    };
}
exports.cssProperty = function (target, key) {
    Object.defineProperty(target, key, {
        get: createGetter(key),
        set: createSetter(key),
        enumerable: true,
        configurable: true,
    });
};
exports.rippleColorProperty = new properties_1.CssProperty({
    name: 'rippleColor',
    cssName: 'ripple-color',
    equalityComparer: core_1.Color.equals,
    valueConverter: function (v) { return new core_1.Color(v); },
});
exports.rippleColorProperty.register(core_1.Style);
exports.elevationProperty = new properties_1.CssProperty({
    name: 'elevation',
    cssName: 'elevation',
    valueConverter: parseFloat,
});
exports.elevationProperty.register(core_1.Style);
exports.dynamicElevationOffsetProperty = new properties_1.CssProperty({
    name: 'dynamicElevationOffset',
    cssName: 'dynamic-elevation-offset',
    valueConverter: parseFloat,
});
exports.dynamicElevationOffsetProperty.register(core_1.Style);
exports.variantProperty = new properties_1.CssProperty({
    name: 'variant',
    cssName: 'variant',
});
exports.variantProperty.register(core_1.Style);
var textAlignmentConverter = properties_1.makeParser(properties_1.makeValidator('initial', 'top', 'middle', 'bottom'));
exports.verticalTextAlignmentProperty = new properties_1.InheritedCssProperty({
    name: 'verticalTextAlignment',
    cssName: 'vertical-text-align',
    defaultValue: 'initial',
    valueConverter: textAlignmentConverter,
});
exports.verticalTextAlignmentProperty.register(core_1.Style);
//# sourceMappingURL=cssproperties.js.map